//  iyv12.h
//
//	YV12 to YUY2 converter
//
//	Copyright (c)
//
#ifndef __IYV12_H__
#define __IYV12_H__


#include "iyv12guids.h"
#include "iyv12prop.h"

class Ciyv12 : public CTransformFilter,
	           public IIYV12,
               public ISpecifyPropertyPages
{
private:
	LONG hIn;
	LONG hOut;
	LONG wIn;
	LONG wOut;
	LONG swIn;
	LONG swOut;
	BYTE *pTemp;
	CCritSec  m_Shared;	// Lf[^ی삷B
	DWORD m_nFunc;			// ϊ֐̑I
	DWORD m_thField;		// tB[hԍ臒l
	DWORD m_thFrame;		// t[ԍ臒l
	DWORD m_dispmode;		// eXg\[h
public:
	DECLARE_IUNKNOWN;
	STDMETHODIMP NonDelegatingQueryInterface(REFIID riid, void ** ppv);
	STDMETHODIMP GetPages(CAUUID *pPages);

	STDMETHODIMP SetFuncN(DWORD nFunc);
	STDMETHODIMP GetFuncN(DWORD *pnFunc);
	STDMETHODIMP SetFieldTH(DWORD thField);
	STDMETHODIMP GetFieldTH(DWORD *pthField);
	STDMETHODIMP SetFrameTH(DWORD thFrame);
	STDMETHODIMP GetFrameTH(DWORD *pthFrame);
	STDMETHODIMP SetDispMode(DWORD dispmode);
	STDMETHODIMP GetDispMode(DWORD *pdispmode);

	Ciyv12(TCHAR *tszName, LPUNKNOWN punk);
	~Ciyv12();

	HRESULT CheckInputType(const CMediaType *mtIn);
	HRESULT GetMediaType(int iPosition, CMediaType *pMediaType);
	HRESULT CheckTransform(const CMediaType *mtIn, const CMediaType *mtOut);
	HRESULT DecideBufferSize(IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *pProp);
	HRESULT Transform(IMediaSample *pSource, IMediaSample *pDest);
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN pUnk, HRESULT *pHr);
};

REGPINTYPES sudInputTypes = { &MEDIATYPE_Video, &MEDIASUBTYPE_YV12 };
REGPINTYPES sudOutputTypes = { &MEDIATYPE_Video, &MEDIASUBTYPE_YUY2 };

// s錾B
REGFILTERPINS sudPinReg[] = {
    // ̓sB
    { 0, FALSE, // Rendered?
         FALSE, // Output?
         FALSE, // Zero?
         FALSE, // Many?
         0, 0, 
         1, &sudInputTypes  // Media types.
    },
    // o̓sB
    { 0, FALSE, // _OĂ邩?
         TRUE, // o?
         FALSE, // [?
         FALSE, // ?
         0, 0, 
         1, &sudOutputTypes      // fBA ^CvB
    }
};
 
// tB^錾B
REGFILTER2 rf2FilterReg = {
    1,                // o[WԍB
    MERIT_DO_NOT_USE, // bgB
    2,                // s̐B
    sudPinReg         // sւ̃|C^B
};


//tB^
static WCHAR g_wszName[] = L"interlaced YV12 to YUY2 converter";
CFactoryTemplate g_Templates[] = 
{
  { 
    g_wszName,
    &CLSID_IYV12,
    Ciyv12::CreateInstance,
    NULL,
    NULL
  },
  {
	L"IYV12 Configuration",
    &CLSID_IYV12Prop,
	Ciyv12Prop::CreateInstance, 
	NULL,
	NULL
  }
};

int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);

#endif /*__IYV12_H__*/

