//  iyv12prop.h
//
//	YV12 to YUY2 converter PropertyPages
//
//	Copyright (c)
//
#ifndef __IYV12PROP_H__
#define __IYV12PROP_H__

/* registry stuff */
#define HWDI_REG_KEY    HKEY_CURRENT_USER
#define HWDI_REG_SUBKEY "Software\\GNU\\HWDI"
#define HWDI_REG_CLASS  "config"

struct IYV12CONF
{
	DWORD nFunc;		// ϊ֐̑I
	DWORD thField;		// tB[hԍ臒l
	DWORD thFrame;		// t[ԍ臒l
	DWORD dispmode;		// eXg\[h
};

interface IIYV12 : public IUnknown
{
	STDMETHOD(GetFuncN)(DWORD *) = 0;
	STDMETHOD(SetFuncN)(DWORD) = 0;
	STDMETHOD(SetFieldTH)(DWORD) = 0;
	STDMETHOD(GetFieldTH)(DWORD *) = 0;
	STDMETHOD(SetFrameTH)(DWORD) = 0;
	STDMETHOD(GetFrameTH)(DWORD *) = 0;
	STDMETHOD(SetDispMode)(DWORD) = 0;
	STDMETHOD(GetDispMode)(DWORD *) = 0;
};

class Ciyv12Prop : public CBasePropertyPage
{
private:
	IIYV12 *m_pIYV12;
	IYV12CONF  m_Val;
	IYV12CONF  m_NewVal;
	void SetDirty(void);

public:
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN lpunk, HRESULT * phr);

	Ciyv12Prop(LPUNKNOWN pUnk);
	~Ciyv12Prop() {}

	HRESULT OnConnect(IUnknown *pUnk);
	HRESULT OnActivate(void);
	BOOL OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	HRESULT OnApplyChanges(void);
	HRESULT OnDisconnect(void);
};


/* registry functions */
void LoadRegistryInfo(IYV12CONF *);
void SaveRegistryInfo(IYV12CONF);

#endif /* __IYV12PROP_H__ */
